/* $Id: keysyms.h,v 1.1 2004/12/27 20:38:45 cegger Exp $
******************************************************************************

   Quartz: Input header

   Copyright (C) 2004 Christoph Egger

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************
*/


#define QUARTZ_F1		0x7A
#define QUARTZ_F2		0x78
#define QUARTZ_F3		0x63
#define QUARTZ_F4		0x76
#define QUARTZ_F5		0x60
#define QUARTZ_F6		0x61
#define QUARTZ_F7		0x62
#define QUARTZ_F8		0x64
#define QUARTZ_F9		0x65
#define QUARTZ_F10		0x6D
#define QUARTZ_F11		0x67
#define QUARTZ_F12		0x6F

#define QUARTZ_1		0x12
#define QUARTZ_2		0x13
#define QUARTZ_3		0x14
#define QUARTZ_4		0x15
#define QUARTZ_5		0x17
#define QUARTZ_6		0x16
#define QUARTZ_7		0x1A
#define QUARTZ_8		0x1C
#define QUARTZ_9		0x19
#define QUARTZ_0		0x1D

#define QUARTZ_a		0x00
#define QUARTZ_b		0x0B
#define QUARTZ_c		0x08
#define QUARTZ_d		0x02
#define QUARTZ_e		0x0E
#define QUARTZ_f		0x03
#define QUARTZ_g		0x05
#define QUARTZ_h		0x04
#define QUARTZ_j		0x26
#define QUARTZ_k		0x28
#define QUARTZ_l		0x25
#define QUARTZ_m		0x2E
#define QUARTZ_n		0x2D
#define QUARTZ_i		0x22
#define QUARTZ_o		0x1F
#define QUARTZ_p		0x23
#define QUARTZ_q		0x0C
#define QUARTZ_r		0x0F
#define QUARTZ_s		0x01
#define QUARTZ_t		0x11
#define QUARTZ_u		0x20
#define QUARTZ_v		0x09
#define QUARTZ_w		0x0D
#define QUARTZ_x		0x07
#define QUARTZ_y		0x10
#define QUARTZ_z		0x06

#define QUARTZ_EQUALS		0x18
#define QUARTZ_LEFTBRACKET	0x21
#define QUARTZ_RIGHTBRACKET	0x1E

#define QUARTZ_MINUS		0x1B

#define QUARTZ_KP_DIVIDE	0x4B
#define QUARTZ_KP_ENTER		0x4C
#define QUARTZ_KP_EQUALS	0x51
#define QUARTZ_KP_MINUS		0x4E
#define QUARTZ_KP_MULTIPLY	0x43
#define QUARTZ_KP_PERIOD	0x41
#define QUARTZ_KP_PLUS		0x45
#define QUARTZ_KP0		0x52
#define QUARTZ_KP1		0x53
#define QUARTZ_KP2		0x54
#define QUARTZ_KP3		0x55
#define QUARTZ_KP4		0x56
#define QUARTZ_KP5		0x57
#define QUARTZ_KP6		0x58
#define QUARTZ_KP7		0x59
#define QUARTZ_KP8		0x5B
#define QUARTZ_KP9		0x5C

#define QUARTZ_CAPSLOCK		0x39
#define QUARTZ_NUMLOCK		0x47
#define QUARTZ_PAUSE		0x71
#define QUARTZ_POWER		0x7F
#define QUARTZ_PRINT		0x69
#define QUARTZ_SCROLLOCK	0x6B

#define QUARTZ_BACKQUOTE	0x32
#define QUARTZ_BACKSLASH	0x2A
#define QUARTZ_COMMA		0x2B
#define QUARTZ_DELETE		0x75
#define QUARTZ_INSERT		0x72
#define QUARTZ_SEMICOLON	0x29
#define QUARTZ_SLASH		0x2C
#define QUARTZ_PERIOD		0x2F
#define QUARTZ_QUOTE		0x27
#define QUARTZ_RETURN		0x24

#define QUARTZ_ESCAPE		0x35
#define QUARTZ_BACKSPACE	0x33
#define QUARTZ_SPACE		0x31
#define QUARTZ_TAB		0x30

#define QUARTZ_LSHIFT		0x38
#define QUARTZ_LCTRL		0x3B
#define QUARTZ_LALT		0x3A
#define QUARTZ_LMETA		0x37
#define QUARTZ_RSHIFT		QUARTZ_LSHIFT
#define QUARTZ_RCTRL		QUARTZ_LCTRL
#define QUARTZ_RALT		QUARTZ_LALT
#define QUARTZ_RMETA		QUARTZ_LMETA

#define QUARTZ_HOME		0x73
#define QUARTZ_PAGEUP		0x74
#define QUARTZ_END		0x77
#define QUARTZ_PAGEDOWN		0x79
#define QUARTZ_LEFT		0x7B
#define QUARTZ_DOWN		0x7D
#define QUARTZ_RIGHT		0x7C
#define QUARTZ_UP		0x7E

#define QUARTZ_NOTEBOOK_ENTER	0x34
#define QUARTZ_NOTEBOOK_LEFT	0xFF	/* 0x3B */
#define QUARTZ_NOTEBOOK_RIGHT	0x3C
#define QUARTZ_NOTEBOOK_DOWN	0x3D
#define QUARTZ_NOTEBOOK_UP	0x3E
